/* ̿ ̧قATMEL QTouchײ،J4.3.1̈ꕔłB */
/* ̧قDoxygenpɏĂ܂B */
/*! \file *********************************************************************
 *
 * \brief ̧قAVR 8ޯāAAVR 32ޯāAATMEL ARMQMatrixQTouch@eʐ
 *		  G̎pQTouchײAPI̪܂݂܂B
 *
 * - ߲			: AVR/AVR32pIAR EWAVR/EWAVR32GNU GCC
 *					  ATMEL ARMpIAR WorkbenchGNU GCC
 * - x޲		: ATMEL AVR 8ޯāAAVR 32ޯāAATMEL ARM
 * - gp҂̎	: QTouchײ؎gp҂̎ - doc8207.pdf
 * - xEҰ		: touch@atmel.com
 *
 * \author Atmel Corporation	: http://www.atmel.com \n
 *		   xFAQ			: http://support.atmel.no/
 *
 ******************************************************************************/

/* 쌠 (c) 2010, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

#ifndef TOUCH_API_H
#define TOUCH_API_H

#include "touch.h"

/*----------------------------------------------------------------------------
							qɂꂽݸٰ ̧
----------------------------------------------------------------------------*/
#if defined (__GNUC__) || defined (__ICCARM__) ||defined (__CC_ARM)
  #include <stdint.h>
#endif

#if !defined (__CC_ARM)
  #include <stdbool.h>
#endif
#include <stdlib.h>
#ifndef MAKE_BUILD
#ifdef _QMATRIX_
#if !(defined(__AVR32__) || defined(__ICCAVR32__))
  #include "qm_asm_avr.h"
#else
  #include "touch_qm_config32.h"
#endif
#elif defined _QTOUCH_
#if !(defined(__AVR32__) || defined(__ICCAVR32__))
  #include "qt_asm_avr.h"
#endif
#else
  #error /* please provide any one of the acquisition methods */
#endif
#endif

#ifdef __ICCAVR__
  #include <intrinsics.h>
#endif /* (__ICCAVR__) */

/*----------------------------------------------------------------------------
								:ײؔł̑I
-----------------------------------------------------------------------------*/
/**
  * QTouchײ؂͏[dԂ͈̔͂Ƌɍ\zċ܂B[dԂ͏[dAVR
  * 瑪e(ݻ)ɓ]鎝ԂłBZ[dԂ͂葬
  * ɋA܂Aeʂւ̊Sȏ[d]邩܂B
  *
  * [dԂ͈̔͂͂߂sۯxɑ΂ēKłgp҂
  * Iт܂B
  *
  * eʐsߑ\I0.25`2.5ŝ悤ȏ[dԂKvƂ܂B
  * ȉ̕\͸ۯx͈̔͂ɑΉ[dԂ܂B
  *
  * ۯx(MHz) ۯ(s) K[d
  * ----------------- --------------- ---------------------
  *		1				1		1`2 (1`2s)
  *		2				0.5		1`5 (0.5`2.5s)
  *		4				0.25	1`10 (0.25`2.5s)
  *		8				0.125	2`10 (0.25`1.25s)
  *		10				0.1		3`25 (0.3`2.5s)
  *		16				0.0625	4`25 (0.25`1.5625s)
  *		20				0.05	5`50 (0.25`2.5s)
  */

/**
  * gpҌ`ԐݒCӑIɑ΂ُ팟͂ŊJn
  */
#ifdef _QMATRIX_

/**
  * exsɑ΂Ċi[
  *
  * eXsɑ΂āAꂪ߰Ă݂͂ĂB
  * Ⴆ΁AX3PB1ȂA4Ԗڂ̓
  * FILL_OUT_X_LINE_INFO( 1,1 )ŁAPORT_X_1BɂȂł傤B
  */
#define FILL_OUT_X_LINE_INFO( port_num,x_bit ) {JOIN(burst_qm_, port_num) ,(TOUCH_DATA_T)( 1u << x_bit ), BURST_MASK_X_PORT_ ## port_num  }

/**
  * eysɑ΂Ċi[
  *
  * eYsɑ΂āAꂪ݂͂ĂB
  * Ⴆ΁AY2PA5PF5ȂA3Ԗڂ̓
  * FILL_OUT_Y_LINE_INFO( 5 )ɂȂł傤B
  * :ǂꂩYsYAYBɑ΂߰ĂPORT_YAPORT_YBƂĒ`邱
  *	   KvɂȂł傤B
  *
  * :̏ꍇłPORT_YA=APORT_YB=F
  */
#if !(defined(__AVR32__) || defined(__ICCAVR32__))
//#define FILL_OUT_Y_LINE_INFO( bit ) { bit, (TOUCH_DATA_T)(1u<<bit) }
  #define FILL_OUT_YA_LINE_INFO( bit ) { bit, (TOUCH_DATA_T)(1u<<bit) }
  #define FILL_OUT_YB_LINE_INFO( bit ) { bit, (TOUCH_DATA_T)(1u<<bit) }
#else
  #define FILL_OUT_YA_LINE_INFO( bit ) { bit, (TOUCH_DATA_T)(1u<<bit) }
  #define FILL_OUT_YB_LINE_INFO( bit ) { bit, (TOUCH_DATA_T)(1u<<bit) }
#endif

/**
  * eyasɑ΂Ċi[
  *
  * eYAsɑ΂āAꂪ݂͂ĂB
  * Ⴆ΁AY2APA5ȂA3Ԗڂ̓
  * FILL_OUT_YA_LINE_INFO( 5 )ɂȂł傤B
  * :ǂꂩYsYAɑ΂߰ĂPORT_YAƂĒ`邱ƂKvɂȂ
  *	   傤B
  *
  * :̏ꍇłPORT_YA=A
  */
//FWRAP: #define FILL_OUT_YA_LINE_INFO( bit ) { bit, (uint8_t)(1u<<bit) }

/**
  * eybsɑ΂Ċi[
  *
  * eYBsɑ΂āAꂪ݂͂ĂB
  * Ⴆ΁AY2BPF3ȂA3Ԗڂ̓
  * FILL_OUT_YB_LINE_INFO( 3 )ɂȂł傤B
  * :ǂꂩYsYBɑ΂߰ĂPORT_YBƂĒ`邱ƂKvɂȂ
  *	   傤B
  *
  * :̏ꍇłPORT_YB=F
  */
//FWRAP: #define FILL_OUT_YB_LINE_INFO( bit ) { bit, (uint8_t)(1u<<bit) }


#ifndef MAKE_BUILD
//! KvȒ`
#if (NUM_X_PORTS==1)
  #if !defined(PORT_X_1) || !defined(PORT_YA) || !defined(PORT_YB) || !defined(QT_DELAY_CYCLES) || !defined(PORT_SMP) || !defined(SMP_BIT)
	#error Need to define PORT_X_1, PORT_YA,PORT_YB,PORT_SMP,SMP_BIT and QT_DELAY_CYCLES before including the header file.
  #endif
#elif(NUM_X_PORTS==2)
  #if !defined(PORT_X_1)||!defined(PORT_X_2) || !defined(PORT_YA) || !defined(PORT_YB) || !defined(QT_DELAY_CYCLES) || !defined(PORT_SMP) || !defined(SMP_BIT)
	#error Need to define PORT_X_1,PORT_X_2, PORT_YA,PORT_YB,PORT_SMP,SMP_BIT and QT_DELAY_CYCLES before including the header file.
  #endif
#elif(NUM_X_PORTS==3)
  #if !defined(PORT_X_1)||!defined(PORT_X_2) ||!defined(PORT_X_3)|| !defined(PORT_YA) || !defined(PORT_YB) || !defined(QT_DELAY_CYCLES) || !defined(PORT_SMP) || !defined(SMP_BIT)
	#error Need to define PORT_X_1,PORT_X_2,PORT_X_3, PORT_YA,PORT_YB,PORT_SMP,SMP_BIT and QT_DELAY_CYCLES before including the header file.
  #endif
#endif
#ifdef _ROTOR_SLIDER_
  #if (QT_NUM_CHANNELS == 4u)
	#if !(QT_MAX_NUM_ROTORS_SLIDERS == 1u)
	  #error QT_MAX_NUM_ROTORS_SLIDERS should be define as 1
	#endif
  #elif (QT_NUM_CHANNELS == 8u)
	#if !(QT_MAX_NUM_ROTORS_SLIDERS == 2u)
	  #error QT_MAX_NUM_ROTORS_SLIDERS should be define as 2
	#endif
  #elif (QT_NUM_CHANNELS == 16u)
	#if !((QT_MAX_NUM_ROTORS_SLIDERS == 2u) || (QT_MAX_NUM_ROTORS_SLIDERS == 4u))
	  #error QT_MAX_NUM_ROTORS_SLIDERS should be define as 2 or 4 based on library selected
	#endif
  #elif (QT_NUM_CHANNELS == 24u)
	#if !((QT_MAX_NUM_ROTORS_SLIDERS == 3u))
	  #error QT_MAX_NUM_ROTORS_SLIDERS should be define as 3
	#endif
  #elif (QT_NUM_CHANNELS == 32u)
	#if !(QT_MAX_NUM_ROTORS_SLIDERS == 4u)
	  #error QT_MAX_NUM_ROTORS_SLIDERS should be define as 4 based on library selected
	#endif
  #elif (QT_NUM_CHANNELS == 64u)
	#if !((QT_MAX_NUM_ROTORS_SLIDERS == 4u) || (QT_MAX_NUM_ROTORS_SLIDERS == 8u))
	  #error QT_MAX_NUM_ROTORS_SLIDERS should be define as 4 or 8 based on library selected
	#endif
  #endif
#else
  #if !(QT_MAX_NUM_ROTORS_SLIDERS == 0u)
	#error QT_MAX_NUM_ROTORS_SLIDERS should be define as 0 Or _ROTOR_SLIDER_ Macro Needs to be define
  #endif
#endif

#endif //! MAKE_BUILD.
#endif //! _QMATRIX_
/**
  * gpҌ`ԐݒCӑIɑ΂ُ팟͂ŏI
  */

/**
  * x! ̍sȉҏWȂłB
  */

/*----------------------------------------------------------------------------
									  ϸ
----------------------------------------------------------------------------*/
/**
  * ߰ ڼ޽gpèè ϸ
  */
#define JOIN( x, y ) x ## y
#define JOIN1( A, B, C ) A ## B ## C

/**
  * ߰Ă𐧌䂷邽߂ڼ޽݂\z邽߂ϸہBԂJOINϸۂ͈
  * ĝ߂ɕKvƂ܂B
  */
#define REG( REGISTER, SIDE ) JOIN( REGISTER, SIDE )
#define CONCAT( A, B, C ) JOIN1( A, B, C )

/**
  * \ȍő労m퐔񍐂̂ɕKvƂ޲Đ
  */
#define QT_NUM_SENSOR_STATE_BYTES ( ( QT_NUM_CHANNELS + 7u ) / 8u )

/**
  * ޯނŎgp׸
  */
#define QTLIB_NO_ACTIVITY				(uint16_t) 0x0000	//!< Ȃ
#define QTLIB_IN_DETECT					(uint16_t) 0x0001	//!< Œ1̊m킪o
#define QTLIB_STATUS_CHANGE				(uint16_t) 0x0002	//!< Ōmeasure_sensorsĂяoŒ1̊m킪ON/OFFω
#define QTLIB_ROTOR_SLIDER_POS_CHANGE	(uint16_t) 0x0004	//!< Ōmeasure_sensorsĂяoŒ1̉]q/qʒuω
#define QTLIB_CHANNEL_REF_CHANGE		(uint16_t) 0x0008	//!< Ōmeasure_sensorsĂяoŒ1̎QƊlω
#define QTLIB_BURST_AGAIN				(uint16_t) 0x0100	//!< FILTERINAFILTEROUT܂RECALIBRATEԂ邽߂ɍďWKv
#define QTLIB_RESOLVE_CAL				(uint16_t) 0x0200	//!< CALIBRATION邽߂ɍďWKv
#define QTLIB_RESOLVE_FILTERIN			(uint16_t) 0x0400	//!< FILTERING邽߂ɍďWKv
#define QTLIB_RESOLVE_DI				(uint16_t) 0x0800	//!< RECAL邽߂ɍďWKv
#define QTLIB_RESOLVE_POS_RECAL			(uint16_t) 0x1000	//!< RECAL邽߂ɍďWKv

/*----------------------------------------------------------------------------
									^`
----------------------------------------------------------------------------*/
#if defined (__ICCAVR__) || defined (__ICCAVR32__)
typedef signed char int8_t;			//!< t8ޯĒl
typedef unsigned char uint8_t;		//!< Ȃ8ޯĒl
typedef unsigned short uint16_t;	//!< Ȃ16ޯĒl
typedef short int16_t;				//!< t16ޯĒl
typedef unsigned long uint32_t;		//!< t32ޯĒl
#endif

/**
  * ̺ނ̂̕ײؑIɎgp܂B̺ނ͎܂B
  */
#ifdef _QTOUCH_

  #ifdef QTOUCH_STUDIO_MASKS
	#define CALCULATE_MASKS				NULL
  #else
	#define CALCULATE_MASKS				calc_masks
  #endif

  #if defined (__AVR32__) || defined (__ICCAVR32__) || defined (_TOUCH_ARM_)
	#if (QT_NUM_CHANNELS <= 8u && QT_NUM_CHANNELS != 0u)
	  #define TOUCH_DATA_T				uint8_t
	#elif (QT_NUM_CHANNELS > 8u && QT_NUM_CHANNELS <= 16u)
	  #define TOUCH_DATA_T				uint16_t
	#elif (QT_NUM_CHANNELS > 16u && QT_NUM_CHANNELS <= 32u)
	  #define TOUCH_DATA_T				uint32_t
	#else
	  #error 'The number of channels specified is not supported.'
	#endif
  #else
	#define TOUCH_DATA_T				uint8_t
  #endif

  #ifndef MAKE_BUILD
	#if !(defined(__AVR32__) || defined(__ICCAVR32__)) || defined(_TOUCH_ARM_)
	  #if (QT_NUM_CHANNELS == 16u)
		#ifndef _STATIC_PORT_PIN_CONF_
		  #define _STATIC_PORT_PIN_CONF_
		  #define QTOUCH_SNS_PORT_COUNT		2u
		#endif
	  #else
		#ifdef INTRABURST_1
		  #ifndef _STATIC_PORT_PIN_CONF_
			#define _STATIC_PORT_PIN_CONF_
			#define QTOUCH_SNS_PORT_COUNT	1u
		  #endif
		#endif
		#ifndef SNS1
		  #define SNS1						SNS
		#endif
		#ifndef SNSK1
		  #define SNSK1						SNSK
		#endif
	  #endif
	#else
	  #ifdef INTRABURST_1
		#ifndef _STATIC_PORT_PIN_CONF_
		  #define _STATIC_PORT_PIN_CONF_
		  #define QTOUCH_SNS_PORT_COUNT		1u
		#endif
		#define SNS1						SNS
		#define SNSK1						SNSK
	  #endif
	#endif
	#ifdef _ROTOR_SLIDER_
	  #if !defined(QT_MAX_NUM_ROTORS_SLIDERS)
		#if (QT_NUM_CHANNELS == 4)
		  #define QT_MAX_NUM_ROTORS_SLIDERS	1
		#elif (QT_NUM_CHANNELS == 8)
		  #define QT_MAX_NUM_ROTORS_SLIDERS	2
		#elif (QT_NUM_CHANNELS == 12)
		  #define QT_MAX_NUM_ROTORS_SLIDERS	3
		#elif (QT_NUM_CHANNELS == 16)
		  #define QT_MAX_NUM_ROTORS_SLIDERS	4
		#elif (QT_NUM_CHANNELS == 32)
		  #define QT_MAX_NUM_ROTORS_SLIDERS	8
		#endif
	  #endif
	#else
	  #define QT_MAX_NUM_ROTORS_SLIDERS		0
	#endif
  #endif

  #if !(defined(__AVR32__) || defined(__ICCAVR32__) || defined(_TOUCH_ARM_))
	//! Apϸ
//	#define JOIN3( a, b, c, d, e ) burst_ ## a ## _ ## b ## _ ## c ## d ## _ ## e
	#define JOIN4( a, b, c, d, e , f ) burst_ ## a ## _ ## b ## _ ## c ## d ## _ ## e ##_ ## f
//	#define BURST_JOIN( static_flag, num_ports, intra1, intra2, pow_opt ) JOIN3( static_flag, num_ports, intra1, intra2, pow_opt )
	#define BURST_JOIN( static_flag, num_ports, intra1, intra2, pow_opt, qtouch_pin_conf ) JOIN4( static_flag, num_ports, intra1, intra2, pow_opt, qtouch_pin_conf )

	//! W֐ւ߲\z
	#define BURST_FUNC_NAME		BURST_JOIN( _STATIC_PORT_PIN_CONF_, QTOUCH_SNS_PORT_COUNT, INTRABURST_1, INTRABURST_2, _POWER_OPTIMIZATION_, QTOUCH_PIN_CONF )
//	#define BURST_FUNC_NAME		BURST_JOIN( _STATIC_PORT_PIN_CONF_, QTOUCH_SNS_PORT_COUNT, INTRABURST_1, INTRABURST_2, _POWER_OPTIMIZATION_ )

extern void BURST_FUNC_NAME (TOUCH_DATA_T mask_index);	//!< W֐^BނꎩgڐGײ؂Ɋi[܂B
extern void (*burst_proc) (TOUCH_DATA_T mask_index);	//!< WɎgp֐߲

  #else
	#ifndef _STATIC_PORT_PIN_CONF_

/**
  * SNSSNSK߰đIBɑ΂铯߰Ă̑I͓߰ďW`ԐݒłB
  * CӑIB,C,DłB
  */
#define QT_SNS_PORT						SNS
#define QT_SNSK_PORT					SNSK

//! KvȒ`
#if !defined(QT_SNS_PORT) || !defined(QT_SNSK_PORT) || !defined(QT_DELAY_CYCLES)
  #error Need to define QT_SNS_PORT, QT_SNSK_PORT, and QT_DELAY_CYCLES before including this header file.
#endif

//! Apϸ
#define JOIN3( a, b, c ) burst_ ## a ## _ ## b ## c
#define BURST_JOIN( cycles, snsk, sns ) JOIN3( cycles, snsk, sns )

//! W֐p߲\z
#define BURST_FUNC_NAME		BURST_JOIN( QT_DELAY_CYCLES, QT_SNSK_PORT , QT_SNS_PORT)

#else

//! ÓI߰ ݌`Ԑݒ\錾
#if (QTOUCH_SNS_PORT_COUNT > 0u)
//! ŏSNS-SNSK߰ ݑ
#define QT_SNS1_PORT					SNS1
#define QT_SNSK1_PORT					SNSK1

#if !defined(QT_SNS1_PORT) || !defined(QT_SNSK1_PORT) || !defined(QT_DELAY_CYCLES) || !defined(QT_NUM_CHANNELS) || \
	!defined(QT_MAX_NUM_ROTORS_SLIDERS)
  #error Need to define QT_SNS1_PORT, QT_SNSK1_PORT, QT_DELAY_CYCLES, QT_NUM_CHANNELS and QT_MAX_NUM_ROTORS_SLIDERS before including this header file.
#endif
#endif

#if (QTOUCH_SNS_PORT_COUNT > 1u) && !defined(_TOUCH_ARM_)
  #error 'Maximum of only 1 SNS-SNSK port pairings are supported by the UC3 libraries.'
#elif (QTOUCH_SNS_PORT_COUNT == 0u)
  #error 'Invalid QTOUCH_SNS_PORT_COUNT value.'
#endif /*  QTOUCH_SNS_PORT_COUNT   */

#if (QTOUCH_SNS_PORT_COUNT > 1u)
//! 2ڂSNS-SNSK߰ ݑ
#define QT_SNS2_PORT SNS2
#define QT_SNSK2_PORT SNSK2

#if !defined(QT_SNS2_PORT) || !defined(QT_SNSK2_PORT) || !defined(QT_DELAY_CYCLES) || !defined(QT_NUM_CHANNELS) || \
	!defined(QT_MAX_NUM_ROTORS_SLIDERS)
  #error Need to define QT_SNS2_PORT, QT_SNSK2_PORT, QT_DELAY_CYCLES, QT_NUM_CHANNELS and QT_MAX_NUM_ROTORS_SLIDERS  before including this header file.
#endif
#endif

#if (QTOUCH_SNS_PORT_COUNT == 1u)

//! Apϸ
#define JOIN3( a, b, c, d, z ) burst_ ## a ## _ ## b ## c
#define BURST_JOIN( cycles, snsk1, sns1, ch, rs ) JOIN3( cycles, snsk1, sns1, ch, rs )

//! W֐ւ߲\z
#define BURST_FUNC_NAME		BURST_JOIN( QT_DELAY_CYCLES, QT_SNSK1_PORT , QT_SNS1_PORT, QT_NUM_CHANNELS, \
										QT_MAX_NUM_ROTORS_SLIDERS)

#elif (QTOUCH_SNS_PORT_COUNT == 2u)
#if defined(_TOUCH_ARM_)
//! Apϸ
#define JOIN3( a, b, c, e, f, d, z ) burst_ ## a ## _ ## b ## c ## _ ## e ## f
#define BURST_JOIN( cycles, snsk1, sns1, snsk2, sns2, ch, rs ) JOIN3( cycles, snsk1, sns1, snsk2, sns2, ch, rs )

//! 
#define BURST_FUNC_NAME		BURST_JOIN( QT_DELAY_CYCLES, QT_SNSK1_PORT , QT_SNS1_PORT, QT_SNSK2_PORT , QT_SNS2_PORT, QT_NUM_CHANNELS, \
										QT_MAX_NUM_ROTORS_SLIDERS)
#endif
#else
  #error 'Invalid QTOUCH_SNS_PORT_COUNT value.'
#endif

#endif

extern void BURST_FUNC_NAME (TOUCH_DATA_T mask_index);	//!< W֐^BގgڐGײ؂Ɋi[܂B
extern void (*burst_proc) (TOUCH_DATA_T mask_index);	//!< WɎgp֐߲
#endif

#endif

/**
  * QMATRIXJn
  */
#ifdef _QMATRIX_

// #ifdef __AVR32__
#if defined (__AVR32__) || defined (__ICCAVR32__)
  #define TOUCH_DATA_T uint32_t
#else
  #define TOUCH_DATA_T uint8_t
#endif

//! Apϸ
#define BURST_JOIN(A,B) JOIN(A,B)
#if (NUM_X_PORTS ==1)
  #define BURST_FUNC_1 BURST_JOIN(burst_qm_,PORT_NUM_1)
  extern void BURST_FUNC_1 (uint8_t channel, TOUCH_DATA_T x_mask);
#elif (NUM_X_PORTS ==2)
  #define BURST_FUNC_1 BURST_JOIN(burst_qm_,PORT_NUM_1)
  extern void BURST_FUNC_1 (uint8_t channel, TOUCH_DATA_T x_mask);
  #define BURST_FUNC_2 BURST_JOIN(burst_qm_,PORT_NUM_2)
  extern void BURST_FUNC_2 (uint8_t channel, TOUCH_DATA_T x_mask);
#elif (NUM_X_PORTS ==3)
  #define BURST_FUNC_1 BURST_JOIN(burst_qm_,PORT_NUM_1)
  extern void BURST_FUNC_1 (uint8_t channel, TOUCH_DATA_T x_mask);
  #define BURST_FUNC_2 BURST_JOIN(burst_qm_,PORT_NUM_2)
  extern void BURST_FUNC_2 (uint8_t channel, TOUCH_DATA_T x_mask);
  #define BURST_FUNC_3 BURST_JOIN(burst_qm_,PORT_NUM_3)
  extern void BURST_FUNC_3 (uint8_t channel, TOUCH_DATA_T x_mask);
#endif

extern void (*burst_proc_qm) (uint8_t channel, TOUCH_DATA_T drive_mask);	//!< WɎgp֐߲
typedef void (*PF_CHANNEL) (uint8_t channel);								//!< قɑ΂ČĂ΂ׂ֐ւ߲
typedef void (*PFV) (uint8_t channel, TOUCH_DATA_T line_mask);				//!< voidԂ֐ւ߲
typedef struct tag_x_line_info_t			//!< exsɑ΂Ċi[ꂽ
{
	PFV p_burst_function;					//!< ̍sŏW邽߂̊֐ւ߲
	TOUCH_DATA_T mask;						//!< xs쓮/ێ邽߂ޯĎՕ
	TOUCH_DATA_T burst_mask_array_index;	//!< WՕ̔zւ̎wW
} x_line_info_t;

typedef struct tag_y_line_info_t			//!< eysɑ΂Ċi[ꂽ
{
	TOUCH_DATA_T bit;						//!< ysɂǂޯ
	TOUCH_DATA_T mask;						//!< ysɑ΂Օ
} y_line_info_t;

typedef enum tag_burst_mask_t				//!< F؂ꂽWՕ̗
{
	BURST_MASK_YA,							//! yaspՕ
	BURST_MASK_YB,							//! ybspՕ
	BURST_MASK_X_PORT_1,					//! ߰1xspՕ
	BURST_MASK_X_PORT_2,					//! ߰2xspՕ
	BURST_MASK_X_PORT_3,					//! ߰3xspՕ
	NUM_BURST_MASKS							//! Օ
} burst_mask_t;
/**
  * eQMateixقł̏W
  *
  * P:ٽ
  * l:64ٽ
  */
extern uint8_t qt_burst_lengths[QT_NUM_CHANNELS];

#endif /* _QMATRIX_ */
/**
  * QMATRIXI
  */

typedef uint8_t threshold_t;			//!< m팟o臒lݒ肷镄Ȃ8ޯĒl
typedef enum tag_sensor_type_t			//!< p\Ȋm`ɑ΂CӑI
{
	SENSOR_TYPE_UNASSIGNED,
	SENSOR_TYPE_KEY,
	SENSOR_TYPE_ROTOR,
	SENSOR_TYPE_SLIDER
} sensor_type_t;

/**
  * ǂꂩ̊m킪ȂAǂAKSQ
  *
  *  NO_AKS_GROUP = mAKSQł͂ȂA}꓾܂B
  *  AKS_GROUP_x  = mAKSQxłB
  */
typedef enum tag_aks_group_t
{
	NO_AKS_GROUP,
	AKS_GROUP_1,
	AKS_GROUP_2,
	AKS_GROUP_3,
	AKS_GROUP_4,
	AKS_GROUP_5,
	AKS_GROUP_6,
	AKS_GROUP_7
} aks_group_t;

typedef enum tag_channel_t				//!< m
{
#if (QT_NUM_CHANNELS > 0u)
	CHANNEL_0,
	CHANNEL_1,
	CHANNEL_2,
	CHANNEL_3
#endif
#if (QT_NUM_CHANNELS > 4u)
	, CHANNEL_4,
	CHANNEL_5,
	CHANNEL_6,
	CHANNEL_7
#endif
#if (QT_NUM_CHANNELS > 8u)
	, CHANNEL_8,
	CHANNEL_9,
	CHANNEL_10,
	CHANNEL_11
#endif
#if (QT_NUM_CHANNELS > 12u)
	, CHANNEL_12,
	CHANNEL_13,
	CHANNEL_14,
	CHANNEL_15
#endif
#if (QT_NUM_CHANNELS > 16u)
	, CHANNEL_16,
	CHANNEL_17,
	CHANNEL_18,
	CHANNEL_19,
	CHANNEL_20,
	CHANNEL_21,
	CHANNEL_22,
	CHANNEL_23
#endif
#if (QT_NUM_CHANNELS > 24u)
	, CHANNEL_24,
	CHANNEL_25,
	CHANNEL_26,
	CHANNEL_27,
	CHANNEL_28,
	CHANNEL_29,
	CHANNEL_30,
	CHANNEL_31
#endif
#if (QT_NUM_CHANNELS > 32u)
	, CHANNEL_32,
	CHANNEL_33,
	CHANNEL_34,
	CHANNEL_35,
	CHANNEL_36,
	CHANNEL_37,
	CHANNEL_38,
	CHANNEL_39,
	CHANNEL_40,
	CHANNEL_41,
	CHANNEL_42,
	CHANNEL_43,
	CHANNEL_44,
	CHANNEL_45,
	CHANNEL_46,
	CHANNEL_47,
	CHANNEL_48,
	CHANNEL_49,
	CHANNEL_50,
	CHANNEL_51,
	CHANNEL_52,
	CHANNEL_53,
	CHANNEL_54,
	CHANNEL_55
#endif
#if (QT_NUM_CHANNELS > 56u)
	, CHANNEL_56,
	CHANNEL_57,
	CHANNEL_58,
	CHANNEL_59,
	CHANNEL_60,
	CHANNEL_61,
	CHANNEL_62,
	CHANNEL_63
#endif
} channel_t;

/**
  * m팟o˽ؼlB͊m팟o臒l%ŕ\܂B
  *
  *  HYST_x = ˽ؼl͌o臒lx%ł(ۂߐ؎̂)B
  *  :ŏl2gp܂B
  *
  *  :o臒l20ȂA
  *		HYST_50   = 10 (2050%)
  *		HYST_25   = 5  (2025%)
  *		HYST_12_5 = 2  (2012.5%)
  *		HYST_6_25 = 2  (206.25%=1łAl2ɐ܂B)
  */
typedef enum tag_hysteresis_t
{
	HYST_50,
	HYST_25,
	HYST_12_5,
	HYST_6_25
} hysteresis_t;

/**
  * ]qƐqɑ΂ĕ񍐂px܂͈ʒu̕\
  *
  *  RES_x_BIT = ]q/qxޯĒl񍐂܂B
  *
  *  :q̕\RES_7_BITȂA񍐂ʒu0`127͈͓̔łB
  */
typedef enum tag_resolution_t
{
	RES_1_BIT,
	RES_2_BIT,
	RES_3_BIT,
	RES_4_BIT,
	RES_5_BIT,
	RES_6_BIT,
	RES_7_BIT,
	RES_8_BIT
} resolution_t;

/**
  * mčZ臒lB͊m팟o臒l%Ƃĕ\܂B
  *
  *  RECAL_x = čZ臒l͌o臒lx%ł(ۂߐ؎̂)B
  *  :ŏl4gp܂B
  *
  *  :o臒l=40ȂA
  *		RECAL_100  = 40 (40100%)
  *		RECAL_50   = 20 (4050%)
  *		RECAL_25   = 10 (4025%)
  *		RECAL_12_5 = 5  (4012.5%)
  *		RECAL_6_25 = 4  (406.25%=2łAl4ɐ܂B)
  */
typedef enum tag_recal_threshold_t
{
	RECAL_100,
	RECAL_50,
	RECAL_25,
	RECAL_12_5,
	RECAL_6_25
} recal_threshold_t;

typedef struct tag_qt_touch_status_t	//!< ײ؊m̏
{
	/**
	  * ײ؊m̏(ON/OFF)
	  *  ޯ'n'= m'n'̏
	  *  ޯ 0 = sensor_states[0]ޯ0
	  *  ޯ 1 = sensor_states[0]ޯ1
	  *  `
	  *  ޯ 7 = sensor_states[0]ޯ7
	  *  ޯ 8 = sensor_states[1]ޯ0
	  *  ޯ 9 = sensor_states[1]ޯ1
	  *  ` Ȃ
	  *  0=oȂA1=o
	  */
	uint8_t sensor_states[QT_NUM_SENSOR_STATE_BYTES];
	/**
	  * ]qpx܂͐qʒu
	  *  ̒lsensor_statesΉ]q܂͐q̌o
	  *  ɗLłB
	  */
	uint8_t rotor_slider_values[QT_MAX_NUM_ROTORS_SLIDERS];
} qt_touch_status_t;

//! ޯ ̪Mꂽ㏈`Ԑݒް
typedef struct tag_qt_touch_lib_config_data_t
{
	recal_threshold_t qt_recal_threshold;	//!< mčZ臒l
	uint8_t qt_di;							//!< m팟oϕ(DI)x
	uint8_t qt_drift_hold_time;				//!< mϓێ
	uint8_t qt_max_on_duration;				//!< mőONێ
	uint8_t qt_neg_drift_rate;				//!< m핉ϓx
	uint8_t qt_pos_drift_rate;				//!< m퐳ϓx
	uint8_t qt_pos_recal_delay;				//!< čZx
} qt_touch_lib_config_data_t;

//! ޯނƔ̂߂ɑ鑪肵ڐGް
typedef struct tag_qt_touch_lib_measure_data_t
{
	uint16_t channel_signals[QT_NUM_CHANNELS];		//!< eقő肵M
	uint16_t channel_references[QT_NUM_CHANNELS];	//!< eقɑ΂QƊM
	qt_touch_status_t qt_touch_status;				//!< m̏
} qt_touch_lib_measure_data_t;

//! ײ؂ײ؏𓾂邽߂Ɏgp܂B
typedef struct qt_lib_sig_info_t
{
	uint16_t lib_sig_lword;
	uint16_t lib_sig_hword;
	uint16_t library_version;
} qt_lib_siginfo_t;

typedef struct tag_sensor_t
{
	uint8_t state;				//!< m(ZAONȂ)
	uint8_t general_counter;	//!< ėpv:ZAϓȂǂɎgp
	uint8_t ndil_counter;		//!< DIv
	uint8_t threshold;			//!< m팟o臒l

	/**
	  * m`AAKSQAčZ׸ށA˽ؼl
	  * ޯ7`6: m`: 00: 
	  *						  01: ]q
	  *						  10: q
	  *						  11: (\)
	  * ޯ5`3: AKSQ(0`7):0=AKSQȂ
	  * ޯ2   : čZ׸
	  * ޯ1`0: ˽ؼ
	  */
	uint8_t type_aks_pos_hyst;

	/**
	  * mق̊֌W
	  * :from channel=to channel
	  * ]q/qfromtoيԂœ܂B
	  * :]q/q\z෰ɑ΂Ăto_channelKvłB
	  */
	uint8_t from_channel;

#ifdef _ROTOR_SLIDER_
	uint8_t to_channel;
	uint8_t index;						//!< ]q/ql̔zւ̎wW
#endif /* _ROTOR_SLIDER_ */
} sensor_t;

/*----------------------------------------------------------------------------
									Oϐ
----------------------------------------------------------------------------*/
/**
  * ̌`Ԑݒް\Ұ͕ύXKvꍇqt_set_parameters֐
  * ŕύX܂B
  */
extern qt_touch_lib_config_data_t qt_config_data;
extern qt_touch_lib_measure_data_t qt_measure_data;		//!< ް
extern int16_t qt_get_sensor_delta (uint8_t sensor);	//!< m퍷l擾
extern uint16_t lib_status_flags;						//!< ׸ނێϐ
extern sensor_t sensors[QT_NUM_CHANNELS];				//!< ײ؊m
extern uint16_t qt_measurement_period_msec;				//!< msł̌v

/*----------------------------------------------------------------------------
									 API
----------------------------------------------------------------------------*/
/*! \brief ̊֐ײ؂eʐsŁAO
 * ɌĂ΂܂Bgp҂͑肵Mlhg֐Kp邽߂ɂ̈|
 * gp邱Ƃł܂B
 *
 */
extern void (*qt_filter_callback) (void);

/*! \brief ײ؎[擾
 *
 * \param  qt_lib_siginfo_t: lib_sig_ptr=ײ؎[\̂ւ߲
 */
extern void qt_get_library_sig (qt_lib_siginfo_t * lib_sig_ptr);

/*! \brief m틖
 *
 * \param	channel				: m킪gpǂꂩ̐ڐG
 * \param	aks_group			: ꂩ̊m킪ꍇ̂ǂꂩAKSQ
 * \param	detect_threshold	: m팟o臒l
 * \param	detect_hysteresis	: m팟o˽ؼl
 *
 * \note ɑΉ銴mԍ͋Ă銴m̏Ɉˑ܂Bŏɋ
 *		 銴m킪m0Am1AȉlłB
 *
 *		 ݂̌̏(ON/OFF)qt_touch_status.sensor_statesŒׂ邱Ƃ
 *		 ܂B
 */
extern void qt_enable_key (channel_t channel,
						   aks_group_t aks_group,
						   threshold_t detect_threshold,
						   hysteresis_t detect_hysteresis);

/*! \brief ڐGm
 *
 * \note ̊֐ĂԑO(qt_enable_xxx()gp)KvƂǂ̊m
 *		 Ȃ΂Ȃ܂B
 *
 *		 ̊֐͓ײؕϐvZĐڐGق`Ԑݒ肵A
 *		 qt_measure_sensors()OɌĂ΂Ȃ΂Ȃ܂B
 */
#if defined( _QTOUCH_ )

#define qt_init_sensing( ) qt_init_sensing_with_burst( BURST_FUNC_NAME ,CALCULATE_MASKS)
extern void
qt_init_sensing_with_burst (void (*burst_function) (TOUCH_DATA_T mask_index),
							void (*calculate_masks) (void));
extern void calc_masks (void);
#elif defined( _QMATRIX_ )

#define qt_init_sensing( ) qt_init_sensing_with_burst(  )
extern void qt_init_sensing_with_burst ();

#endif

/*! \brief ڐGm푪
 *
 * \param	current_time_ms	: msł̌ݎ
 * \return	uint16_t		: ײ؏ޯĂo
 * \note ̊֐͋ꂽSĂ̊mŗeʐs܂Bemɑ
 *		 đ肵M͂̌ɎgpҐڐGAJA]qpxł̕ύXAq
 *		 ʒuł̕ύXȂǂɑ΂Ēׂ܂B
 *
 *		 ꂽSĂ̊m݂̌̏Ԃqt_touch_status\̂ŕ񍐂
 *		 B
 *
 *		 ̊֐ĂԑOɁA(qt_enable_xxx()gp)1ȏ̊m킪
 *		 Aqt_init_sensing()Ă΂Ȃ΂Ȃ܂B
 */
extern uint16_t qt_measure_sensors (uint16_t current_time_ms);

/*! \brief ڐGmZ
 *
 * \note ̊֐͋ꂽSĂ̊m̍Z܂B͗ႦΉp
 *		 `ԂɉύXőSĂ̊mS̓IɍčZ邱ƂKvƂ
 *		 ꍇɗLp܂B
 */
extern void qt_calibrate_sensing (void);

/*! \brief ڐGmؾ
 *
 * \note ̊֐͋ꂽSĂ̊m֎~ASĂײؕϐ(Ⴆ΁A
 *		 qt_di)̊lɖ߂܂B
 *
 *		 ͓IȍČ`Ԑݒ芴mɕKvƂꍇɗLp܂B
 *		 ̊֐̌ďoAĂqt_measure_channels()Ă΂OɁAKvƂ
 *		 ǂ̊mAċAqt_init_sensing()Ă΂Ȃ΂Ȃ
 *		 B
 */
extern void qt_reset_sensing (void);

/*! \brief w肵mł݂̌̍擾
 *
 * \param	sensor	: 𓾂邽߂̊mԍ
 * \return	int16_t	: w肵mł̍Ԃ܂B
 * \note ̊֐͏ײؔłŒ񋟂ꂽsensor_deltas[]zɑ΂@\u
 *		 Ƃċ܂B
 */
extern int16_t qt_get_sensor_delta (uint8_t sensor);

#ifdef _ROTOR_SLIDER_

/*! \brief ]qm틖
 *
 * \param	from_channel		: ]qm̍ŏ
 * \param	to_channel			: ]qm̍Ō
 * \param	aks_group			: ꂩ̊m킪ꍇ̂ǂꂩAKSQ
 * \param	detect_threshold	: m팟o臒l
 * \param	detect_hysteresis	: m팟o˽ؼl
 * \param	angle_resolution	: 񍐂pxl̕\
 * \param	angle_hysteresis	: 񍐂pxl˽ؼ
 * \note ]qɑΉ銴mԍ͋ꂽm̏Ɉˑ܂Bŏɋ
 *		 ꂽm킪m0Am1AȉlłB
 *
 *		 ]q݂̌̏(ON/OFF)qt_touch_status.sensor_statesŒׂ邱
 *		 ł܂B
 *
 *		 ]qlqt_touch_status.rotor_slider_values[]łBǂ̔z̗vf
 *		 gp邩͋銴m̏Ɉˑ܂Bŏɋ]q
 *		 rotor_slider_values[0]gpArotor_slider_values[1]gpA
 *		 ĈȉlłB
 *
 *		 񍐂]ql͉]qON̎ɗLłB
 */
extern void qt_enable_rotor (channel_t from_channel,
							 channel_t to_channel,
							 aks_group_t aks_group,
							 threshold_t detect_threshold,
							 hysteresis_t detect_hysteresis,
							 resolution_t angle_resolution,
							 uint8_t angle_hysteresis);

/*! \brief qm틖
 *
 * \param	from_channel		: qm̍ŏ
 * \param	to_channel			: qm̍Ō
 * \param	aks_group			: ꂩ̊m킪ꍇ̂ǂꂩAKSQ
 * \param	detect_threshold	: m팟o臒l
 * \param	detect_hysteresis	: m팟o˽ؼl
 * \param	position_resolution	: 񍐂ʒul̕\
 * \param	position_hysteresis	: 񍐂ʒul˽ؼ
 * \note qɑΉ銴mԍ͋銴m̏Ɉˑ܂Bŏɋ
 *		 ꂽm킪m0Åm킪m1AȉlłB
 *
 *		 q݂̌̏(ON/OFF)qt_touch_status.sensor_statesŒׂ邱
 *		 Ƃł܂B
 *
 *		 qlqt_touch_status.rotor_slider_values[]łBǂ̔z̗vf
 *		 gp邩͋銴m̏Ɉˑ܂Bŏɋ鐠q
 *		 rotor_slider_values[0]gpArotor_slider_values[1]gpA
 *		 ĈȉlłB
 *
 *		 񍐂鐠ql͐qON̎ɗLłB
 */
extern void qt_enable_slider (channel_t from_channel,
							  channel_t to_channel,
							  aks_group_t aks_group,
							  threshold_t detect_threshold,
							  hysteresis_t detect_hysteresis,
							  resolution_t position_resolution,
							  uint8_t position_hysteresis);

#endif

#endif /* TOUCH_API_H */
